#encoding: utf-8
#----------------------------------------
# Mod pour \pokemonsdk\scripts\01500 Alpha 24 Battle Engine (deprecated)\01600 Scene_Battle\00400 Scene_Battle_Functions_p4.rb
#----------------------------------------
#Overhaul de la capture et des bonus ball pour un meilleur équilbrage de la capture.
# - Balls spéciales réequilibrées
# - Capture qui bonifie bien plus le fait d'affaiblir le Pokémon sauvage dans l'esprit de l'anime (à l'exact opposé de la philosophie de Pokémon GO et Let's Go.)
# - Nombres de secousses plus en adéquation avec la probabilité de capture, y compris en cas de capture haut-la-main (moins de 3 secousses dans ce cas là).
# - Déflection de balls et interrupteur de capture interdite. (Rappel : depuis la MàJ de PSDK 24.44 : BT_NoCatch = 43)
# - Divers petits bugs corrigés :) (Phrase d'échec de capture réparées, nombre de secousses de 0 à 3 si échec.)

class Scene_Battle
	# ID des Ultra-Chimères- numéros à compléter par vos soins si besoin. J'ai considéré la lignée Cosmog comme UC.
	remove_const :ULTRA_BEAST
	ULTRA_BEAST = [789,790,791,792,793,794,795,796,797,798,799,800,803,804,805,806]
	# ID des lignés des Pokémons qui évoluent avec une Pierre Lune (Idem, numéros à compléter par vos soins si ajouts de Fakemons.)
	remove_const :MOON_EVOLVE
	MOON_EVOLVE = [29,30,31,32,33,34,35,36,39,40,173,174,300,301,517,518]
	# ID des lignés des Pokémons qui évoluent par bonheur (testé pour la Copain Ball) (Idem, numéros à compléter par vos soins si ajouts de Fakemons.)
	FRIENDSHIP_EVOLVE = [25,26,35,36,39,40,41,42,52,53,113,133,134,135,136,143,169,172,173,174,175,176,183,184,196,197,242,298,315,358,406,407,427,428,433,440,446,447,448,468,470,471,527,528,540,541,542,700,772,773]
	TYPE_LURE = [3, 12] # Type Eau et Insecte testé pour l'Appât Ball
	TYPE_FAIRY = [18] # Type Fée testé pour la Lune Ball
	#===
	#>phase4_try_to_catch_pokemon
	#Fonction de tentative de capture d'un Pokémon
	#===
	def phase4_try_to_catch_pokemon(ball_data,id)
		pokemon=@enemies[@enemies[0].dead? ? 1 : 0]
		hpmax=pokemon.max_hp
		hp=pokemon.hp
		rate=pokemon.rareness
		level_influence=0.1+(72.0/(pokemon.level+50.0))
		#Calcul du bonus de status
		case pokemon.status
		when 1,2,3,8
			bs=1.5
			candeflect=1
		when 4,5
			bs=2.5
			candeflect=0 # Pas de déflection si la capture est possible et que le Pokémon est endormi ou gelé (comme en Gen 1)
		else
			bs=1
			candeflect=1
		end
		#Formule révisée du degré d'affaiblissement du Pokémon sauvage (amplitude de [×0.05 à ×6] contre [×0.333 à ×2] en jeu officiel).
		weakening_rate=(2-((3.8*(hp-1)/hpmax)**0.5))*bs
		#Calcul du bonus de ball utilisé
		bb1=phase4_ball_bonus(ball_data,pokemon)
		bb2=phase4_detect_ub(ball_data,pokemon)
		bb=bb1*bb2
		#Taux préliminaires
		deflect=candeflect*25.5/(weakening_rate*level_influence*(rate+30))
		a=weakening_rate*level_influence*rate*bb
		puts "-- Calcul de capture --"
		puts "Deflect threshold : #{deflect}"
		puts "Weakening rate : #{weakening_rate}"
		puts "Influence du niveau : #{level_influence}"
		puts "Taux de capture : #{rate}"
		puts "Bonus Ball : #{bb}"
		if deflect >= 1 or $game_switches[Yuki::Sw::BT_NoCatch] or $game_temp.trainer_battle == true
			puts "Probabilité : 0/255"
		else
			puts "Probabilité : #{a}/255"
		end
		if rate == 0 or $game_switches[Yuki::Sw::BT_NoCatch] or $game_temp.trainer_battle == true # Capture impossible ou interdite
			cnt=-2
		elsif deflect >= 1 # Ball déviée car Pokémon sauvage pas assez affaibli (comme en Gen 1)
			cnt=-1
		elsif a >= 2040
			cnt=7
		elsif a >= 1020
			cnt=6
		elsif a >= 510
			cnt=5
		elsif a >= 255
			cnt=4
		else
			b=rand()*255
			if b < a
				cnt=4
			elsif b >= a*8
				cnt=0
			elsif b >= a*4
				cnt=1
			elsif b >= a*2
				cnt=2
			else
				cnt=3
			end
		end
		return phase4_animation_capture(cnt,pokemon,id)
	end
	#===
	#>phase4_ball_bonus
	#Calcule le bonus conféré par la balle
	#===
	def phase4_detect_ub(ball_data,pokemon)
		if ULTRA_BEAST.include?(pokemon.id) and ball_data.catch_rate < 255 #On exclut la Master Ball du malus
			return 0.1
		else
			return 1
		end
	end
	def phase4_ball_bonus(ball_data,pokemon)
		data=ball_data.special_catch
		if(data)
			if(types=data[:types])
				if(types.include?(pokemon.type1) or types.include?(pokemon.type2))
					return (data[:catch_rate] ? data[:catch_rate] : ball_data.catch_rate)
				end
			elsif (data[:ub_ball]) # Ultra Ball à paramétrer avec la capture spécifique (hash) : "{ub_ball: true}" dans le Ruby Host (ID de la ball dans le Ruby Host : 851)
				if ULTRA_BEAST.include?(pokemon.id) # Si Ultra-Chimère
					return 50 # La valeur indiquée prend en compte le malus x0.1 qui sera appliqué dans la "def phase4_detect_ub(ball_data,pokemon)"
				else
					return 0.1
				end
			elsif(data[:level]) #Faiblo ball
					return [(4.2-pokemon.level*0.1),1].max
			elsif(data[:time]) #Chrono ball
				return [(0.875+$game_temp.battle_turn*0.13),6].min # Bonus de 1 au tour 1, puis +0.13 à chaque tour écoulé avec un maximum de 6.	
			elsif(data[:bis]) #Bis ball
				return 3 if $pokedex.has_captured?(pokemon.id)
			elsif(data[:scuba]) #Scuba ball
				return 4 if $env.under_water? #Vérifier si on est sous l'eau
				return 2.5 if $env.pond? or $env.sea? or @fished #Vérifier si on est sur l'eau ou en pêche
				return 1
			elsif(data[:dark]) #Sombre ball
				return 3 if $env.night? or $env.cave? #Vérifier si on est la nuit ou dans une grotte
			elsif(data[:speed]) #Rapide Ball
				return [(7-$game_temp.battle_turn),1].max # Bonus de 6 au tour 1, puis -1 à chaque tour écoulé avec un minimum de 1.		
			elsif(data[:speed_pk]) #Speed Ball
				return 6 if $wild_battle.is_roaming?(pokemon) # -- Vérifier si le Pokémon est fuyard
				return 4 if pokemon.base_spd >= 120 # -- 42/904
				return 3.5 if pokemon.base_spd >= 110 # -- 83/904
				return 3 if pokemon.base_spd >= 100 # -- 152/904
				return 2.5 if pokemon.base_spd >= 90 # -- 245/904
				return 2 if pokemon.base_spd >= 80 # -- 332/904
				return 1.5 if pokemon.base_spd >= 70 # -- 420/904 Pokés au-dessus de cette vitesse
				return 0.5 if pokemon.base_spd < 30 # -- 56/904 Pokés au-dessous de cette vitesse - Malus sur les Pokémons très lents
				return 0.6 if pokemon.base_spd < 35 # -- 105/904
				return 0.7 if pokemon.base_spd < 40 # -- 146/904
				return 0.8 if pokemon.base_spd < 45 # -- 204/904
				return 0.9 if pokemon.base_spd < 50 # -- 256/904
				return 1
			elsif(data[:mass])
				return 4 if pokemon.weight >= 500 # -- 16/860 Pokés au-dessus de ce poids. Penser que beaucoups de gros Pokémons auront leur poids revus significativement à la hausse à Keltios.
				return 3.5 if pokemon.weight >= 300 # -- 41/860
				return 3 if pokemon.weight >= 200 # -- 74/860
				return 2.5 if pokemon.weight >= 150 # -- 96/860
				return 2 if pokemon.weight >= 80 # -- 194/860
				return 1.5 if pokemon.weight >= 40 # -- 337/860
				return 0.5 if pokemon.weight < 3 # -- 72/860 Pokés au-dessous de ce poids - Malus sur les Pokémons très légers
				return 0.6 if pokemon.weight < 6 # -- 139/860 
				return 0.7 if pokemon.weight < 9 # -- 203/860 
				return 0.8 if pokemon.weight < 12 # -- 251/860 
				return 0.9 if pokemon.weight < 16 # -- 302/860 
				return 1
			elsif(data[:appat])
				return 4 if @fished	# -- Vérifier que le pokémon vient d'être pêché.
				return 2.5 if TYPE_LURE.include?(pokemon.type1) or TYPE_LURE.include?(pokemon.type2) # Un bonus de 2.5 si le Pokémon possède le type Eau ou Insecte.
				return 1
			elsif(data[:level_ball])
				lvl = @actors[0].level
				if(lvl / 4 > pokemon.level)
					return 6
				elsif(lvl / 3 > pokemon.level)
					return 4
				elsif(lvl / 2 > pokemon.level)
					return 3
				elsif(lvl / 1.5 > pokemon.level)
					return 2
				elsif(lvl > pokemon.level)
					return 1.5
				else
					return 1
				end
			elsif(data[:moon_ball])
				return 4 if MOON_EVOLVE.include?(pokemon.id) # -- ID des lignés des Pokémons qui évoluent avec une Pierre Lune
				return 3 if TYPE_FAIRY.include?(pokemon.type1) or TYPE_FAIRY.include?(pokemon.type2) # -- Si type Fée
				return 1
			elsif(data[:friend_ball]) # Copain Ball à paramétrer avec la capture spécifique (hash) : "{friend_ball: true}" dans le Ruby Host (ID de la ball dans le Ruby Host : 497)
				return 2 if FRIENDSHIP_EVOLVE.include?(pokemon.id) # -- ID des lignés des Pokémons qui évoluent par bonheur
				return 1
			elsif(data[:love])
				if(@actors[0].gender * pokemon.gender == 2) and @actors[0].id == pokemon.id
					return 8 # -- Si Pokémon du dresseur et Pokémon sauvage de la même espèce ET de sexe opposé, bonus x8
				elsif(@actors[0].gender * pokemon.gender == 2)
					return 2 #- Si Pokémon du dresseur et Pokémon sauvage de sexe opposé (mais pas de la même espèce), bonus x2 quand même
				else
					return 1
				end
			end
			return 1
		else
			return ball_data.catch_rate
		end
	end
	#===
	#>phase4_animation_capture
	#Animation de la capture //!!!\\ A terminer !
	#===
	def phase4_animation_capture(cnt,pokemon,id)
		case cnt
		when -1,-2
			gr_deflect_ball(pokemon, id)
		when 3,4
			gr_launch_ball_to_enemy(pokemon, id)
			shake=3
		when 2,5
			gr_launch_ball_to_enemy(pokemon, id)
			shake=2
		when 1,6
			gr_launch_ball_to_enemy(pokemon, id)
			shake=1
		else
			gr_launch_ball_to_enemy(pokemon, id)
			shake=0
		end
		if cnt >= 0
			shake.times do # Détermine nombre de secousses
				gr_animate_ball_on_enemy(pokemon)
			end
		end

		if cnt >= 4
			gr_animate_caught(pokemon)
			#Faire toute la scène de capture
			$game_switches[Yuki::Sw::BT_Catch] = true
			pokemon.captured_with = id
			pokemon.captured_at = Time.new.to_i
			pokemon.trainer_name = $trainer.name
			pokemon.trainer_id = $trainer.id
			pokemon.code_generation(pokemon.shiny, !pokemon.shiny)
			@_EXP_GIVE.push(pokemon) #--------ligne ajoutée pour donner l'XP à la capture.
			start_phase5
		else
			case cnt
			when -2
				$bag.add_item(id, 1) #Le joueur récupère la ball déviée
				if $game_temp.trainer_battle
					display_message(parse_text(18, 69)) # Pokémon d'un dresseur, ball déviée
				else
					display_message(parse_text(100, 8)) # Capture impossible (taux de 0), ball déviée
				end
			when -1
				$bag.add_item(id, 1)
				display_message(parse_text(100, 9)) # Ball déviée par le Pokémon sauvage (pas assez affaibli)
			when 3
				gr_animate_pokebreak(pokemon)
				display_message(parse_text(18, 66))
			when 2
				gr_animate_pokebreak(pokemon)
				display_message(parse_text(18, 65))
			when 1
				gr_animate_pokebreak(pokemon)
				display_message(parse_text(18, 64))
			else
				gr_animate_pokebreak(pokemon)
				display_message(parse_text(18, 63))
			end
		end # rechercher le texte 18, 67 en cas de réussite pour le faire varier. - C'est dans 01400 Scene_Battle_Phase_5.rb -
	end

	# Show the launch ball animation
	# @param pokemon [PFM::Pokemon] Pokemon we try to catch
	# @param id [Integer] ID of the ball in the database
	def gr_launch_ball_to_enemy(pokemon, id)
		pokemon_sprite = gr_get_pokemon_sprite(pokemon)
		origin_sprite = pokemon.position < 0 ? @actor_sprites.first : @enemy_sprites.first
		@ball_sprite = Sprite.new(@viewport).set_bitmap(GameData::Item.ball_data(id).img, :ball)
		@ball_sprite.visible = false
		@animator = Yuki::Basic_Animator.new(load_data('Data/Animations/pokeball_catch.dat'), origin_sprite, pokemon_sprite)
		@animator.parameters[:ball_sprite] = @ball_sprite
		while @animator.update
			@viewport.sort_z
			update_animated_sprites
			Graphics.update unless @animator.terminated?
		end
		@animator = nil
	end

	# --- Ajout - animation créée pour Sacred Phoenix ---
	# Show the deflect ball animation
	# @param pokemon [PFM::Pokemon] Pokemon we try to catch
	# @param id [Integer] ID of the ball in the database
	def gr_deflect_ball(pokemon, id)
		pokemon_sprite = gr_get_pokemon_sprite(pokemon)
		origin_sprite = pokemon.position < 0 ? @actor_sprites.first : @enemy_sprites.first
		@ball_sprite = Sprite.new(@viewport).set_bitmap(GameData::Item.ball_data(id).img, :ball)
		@ball_sprite.visible = false
		@animator = Yuki::Basic_Animator.new(load_data('Data/Animations/pokeball_deflect.dat'), origin_sprite, pokemon_sprite)
		@animator.parameters[:ball_sprite] = @ball_sprite
		while @animator.update
			@viewport.sort_z
			update_animated_sprites
			Graphics.update unless @animator.terminated?
		end
		@animator = nil
	end

	# Show the moving animation of the ball
	# @param pokemon [PFM::Pokemon] Pokemon we try to catch
	def gr_animate_ball_on_enemy(pokemon)
		pokemon_sprite = gr_get_pokemon_sprite(pokemon)
		origin_sprite = pokemon.position < 0 ? @actor_sprites.first : @enemy_sprites.first
		@animator = Yuki::Basic_Animator.new(load_data('Data/Animations/pokeball_move.dat'), origin_sprite, pokemon_sprite)
		@animator.parameters[:ball_sprite] = @ball_sprite
		while @animator.update
			@viewport.sort_z
			update_animated_sprites
			Graphics.update unless @animator.terminated?
		end
		#@ball_sprite.dispose
		@animator = nil
	end

	# Show the catch animation of the ball
	# @param pokemon [PFM::Pokemon] Pokemon we try to catch
	def gr_animate_caught(pokemon)
		pokemon_sprite = gr_get_pokemon_sprite(pokemon)
		origin_sprite = pokemon.position < 0 ? @actor_sprites.first : @enemy_sprites.first
		@animator = Yuki::Basic_Animator.new(load_data('Data/Animations/pokeball_got.dat'), origin_sprite, pokemon_sprite)
		@animator.parameters[:ball_sprite] = @ball_sprite
		while @animator.update
			@viewport.sort_z
			update_animated_sprites
			Graphics.update unless @animator.terminated?
		end
		@animator = nil
	end

	# Show the break animation of the ball
	# @param pokemon [PFM::Pokemon] Pokemon we try to catch
	def gr_animate_pokebreak(pokemon)
		pokemon_sprite = gr_get_pokemon_sprite(pokemon)
		origin_sprite = pokemon.position < 0 ? @actor_sprites.first : @enemy_sprites.first
		@animator = Yuki::Basic_Animator.new(load_data('Data/Animations/pokeball_break.dat'), origin_sprite, pokemon_sprite)
		@animator.parameters[:ball_sprite] = @ball_sprite
		while @animator.update
			@viewport.sort_z
			update_animated_sprites
			Graphics.update unless @animator.terminated?
		end
		@ball_sprite.dispose
		@animator = nil
	end
end