#encoding: utf-8
# ------------------------------
# Mod pour \pokemonsdk\scripts\01200 PFM\00100 Global Systems\01600 Nuzlocke.rb
# ------------------------------

module PFM
	# Class responsive of managing Nuzlocke information and helping to implement the nuzlocke logic
	# @author Logically anime and ralandel
	class Nuzlocke
		# Create a new Nuzlocke object
		def initialize
			@catch_locked_zones = []
		end

		# On efface pour éviter des conflits de mods puisque Death Overhaul ne gère pas du tout comme ça.
		def clear_dead_pokemon
		end
		alias dead clear_dead_pokemon

		# Lock the current zone (prevent Pokemon from being able to be caught here)
		def lock_catch_in_current_zone
			@catch_locked_zones.push($env.master_zone)
		end

		# Tell if catching is locked in the given zone
		# @param id [Integer] ID of the zone
		# @return [Boolean]
		def catching_locked?(id)
			@catch_locked_zones.include?(id)
		end

		# Tell if catching is locked in the current zone
		# @return [Boolean]
		def catching_locked_here?
			catching_locked?($env.master_zone)
		end
	end
end
