#encoding: utf-8
#----------------------------------------
# Mod pour \pokemonsdk\scripts\01200 PFM\00010 Pokemon_Party\00201 Management.rb
#----------------------------------------
# Ajout de nouvelles méthodes pour tester le nombre de Pokémons blessés à divers degrés dans l'équipe (aucun conflit possible)

module PFM
	class Pokemon_Party

		def has_one_of_these_pokemon?(*list_of_pokemon)
			list_of_pokemon.each do |pkmn|
				if has_pokemon?(pkmn)
					return true
				end
			end
			return false
		end

		# Is the party is all dead ?
		# Attention : un oeuf sera considéré comme un Pokémon vivant.
		# @return [Boolean]
		def allmort?
			return @actors.all?(&:mort?) || @actors.all?(&:mort_d?)
		end

		# Number of pokemon that can healed in the party
		# @param max [Integer] the number of Pokemon to check from the begining of the party
		def pokemon_revivable (max = @actors.size)
			if max == 0
				alive = -1 # Pour pouvoir différencier une équipe vide d'une équipe non vide où tous sont morts. (Vide = -1 ; tous morts = 0)
			else
				alive = 0
				eggs = 0
				max.times do |i|
					alive += 1 if @actors[i] and !(@actors[i].mort? || @actors[i].mort_d? || @actors[i].egg?)
					eggs += 1 if @actors[i] and @actors[i].egg?
				end
				if eggs == max
					alive = -1 # Si l'équipe n'a que des oeufs, on la considère comme une équipe vide.
				end
			end
			return alive
		end
		
		# Permet de compter le nombre de Pokémons avec le statut "KO simple".
		def fainted_pokemon (max = @actors.size)
			fainted = 0
				max.times do |i|
				fainted += 1 if @actors[i] and @actors[i].dead? and !(@actors[i].mort? || @actors[i].mort_d? || @actors[i].damaged? || @actors[i].egg?)
				end
			return fainted
		end

		# Permet de compter le nombre de Pokémons avec le statut "KO au bord de la mort".
		def damaged_pokemon (max = @actors.size)
			damaged = 0
				max.times do |i|
				damaged += 1 if @actors[i] and @actors[i].damaged?
				end
			return damaged
		end

		# Permet de compter le nombre de Pokémons avec le statut "KO simple" ou "KO au bord de la mort".
		def out_of_battle (max = @actors.size)
			out_of_battle = 0
				max.times do |i|
				out_of_battle += 1 if @actors[i] and @actors[i].dead? and !(@actors[i].mort? || @actors[i].mort_d? || @actors[i].egg?)
				end
			return out_of_battle
		end
		
	end
end