#encoding: utf-8
#----------------------------------------
# Mod pour \pokemonsdk\scripts\01600 Scene_Battle\01500 Scene_Battle_BEGEND_Turn.rb
#----------------------------------------
# Patch Orbe Vie pour le mort de Death Overhaul (ligne 174 modifiée) !!! Attention aux Conflits de mod, la def fait 314 lignes pour 1 seule ligne modifiée !!!
# + Modif du mod Loyalty Overhaul : les trois orbes font perdre un petit peu d'amitié lorsqu'ils s'activent.
# Divers réequilibrages sur les dégâts/regens des objets tenus

#noyard
# Description: Définition de la phase de début et fin de tour
class Scene_Battle
	def end_turn_actions
		#>Ordre à respecter !!!
		#[Requiem], [Dégats météo], [Prescience], [Baîllement, Voeu, Soins (soins talents, soins items), Vampigraine], [dégats statuts / cauchemar / harcèlement], [Talents (ex : Turbo, Récolte, etc), baie].
		@_launcher=nil
		arr=Array.new
		battlers=BattleEngine.get_battlers
		BattleEngine::_State_sub_update
		#===
		#>Gestion de REQUIEM (OK !)
		#===
		arr.clear
		battlers.each do |i|
			arr<<i if i and i.hp>0 and i.battle_effect.has_perish_song_effect?
		end
		arr.each do |i|
			eff=i.battle_effect
			eff.dec_perish_song_counter
			BattleEngine::_msgp(19, 863, i, NUMB[2] => eff.get_perish_song_counter.to_s)
			if(eff.get_perish_song_counter==0)
				BattleEngine::_message_stack_push([:hp_down, i, i.hp])
			end
		end
		if(BattleEngine::_message_stack_size>0)
			#display_message("Les Pokémon succombent sous l'effet du Requiem.") #???
			phase4_message_display()
		end
		#===
		#>Météo
		#===
		#> Attention, le message apparait à tous les tours une fois calmé !!! (A corriger)
		weather=$env.current_weather
		stop=$env.decrease_weather_duration
		BattleEngine::_message_stack_push([:weather_display, weather, stop]) if weather !=0
		if(stop)
			case weather
			when 1 #Pluie
				BattleEngine::_msgp(18, 93, nil)
			when 2 #Zenith
				BattleEngine::_msgp(18, 92, nil)
			when 3 #Tempête de sable
				BattleEngine::_msgp(18, 94, nil)
			when 4 #Grêle
				BattleEngine::_msgp(18, 95, nil)
			when 5 #Brouillard
				BattleEngine::_msgp(18, 96, nil)
			end
		else
			case weather
			when 1 #Pluie
				BattleEngine::_mp([:global_animation, 493])
			when 2 #Zenith
				BattleEngine::_mp([:global_animation, 492])
			when 3 #Tempête de sable
				BattleEngine::_msgp(18, 98, nil)
				BattleEngine::_mp([:global_animation, 494])
				battlers.each do |i|
					if(i and i.hp>0)
						unless(i.type_rock? or i.type_ground? or i.type_steel?)
							#> Garde Magik / Voile Sable / Baigne Sable / Force Sable / Envelocappe
							unless(!i.battle_effect.has_no_ability_effect? and [17, 13, 145, 158, 141].include?(i.ability)) 
								BattleEngine::_message_stack_push([:hp_down, i, i.max_hp/16])
							end
						end
					end
				end
			when 4 #Grêle
				BattleEngine::_msgp(18, 99, nil)
				BattleEngine::_mp([:global_animation, 495])
				battlers.each do |i|
					if(i and i.hp>0)
						unless(i.type_ice?)
							#>Garde magik / Corps Gel / Rideau Neige / Envelocape
							unless(!i.battle_effect.has_no_ability_effect? and [17, 106, 83, 141].include?(i.ability)) 
								BattleEngine::_message_stack_push([:hp_down, i, i.max_hp/16])
							end
						end
					end
				end
			end
		end
		BattleEngine::Abilities.on_weather_change
		phase4_message_display() if(BattleEngine::_message_stack_size>0)
		#===
		#>Gestion de prescience et carnareket (OK !)
		#===
		battlers.each do |i|
			if(i and i.hp>0 and i.battle_effect.is_locked_by_future_skill?)
				if(i.battle_effect.get_future_skill_counter==1)
					dmg=i.battle_effect.get_future_damage
					skill_name = GameData::Skill.name(i.battle_effect.get_future_skill_id)
					BattleEngine::_message_stack_push([:msgf, parse_text_with_pokemon(19, 1086, i, MOVE[1] => skill_name)])
					if(dmg <= 0)
						BattleEngine::_message_stack_push([:msg_fail])
					else
						BattleEngine::_message_stack_push([:hp_down, i, dmg])
					end
					i.battle_effect.set_future_skill(nil, -1, nil)
					phase4_message_display()
				end
			end
		end
		#===
		#>Bâillement
		#===
		battlers.each do |i|
			if(i and !i.dead? and i.battle_effect.fell_asleep_from_yawning?)
				#> Garde Magik
				if i.battle_effect.has_no_ability_effect? or i.ability != 17
					_mp([:status_sleep, i, nil, 306, true]) #>Message ?
				end
			end
		end
		#===
		#>Gestion de voeux (OK !)
		#===
		battlers.each do |i|
			if(i and !i.dead? and i.battle_effect.has_wish_effect?)
				BattleEngine::_mp([:msg, parse_text_with_pokemon(19, 700, i.battle_effect.get_wisher)])
				BattleEngine::_message_stack_push([:hp_up, i, i.max_hp / 2])
			end
		end
		#===
		#>Gestion de Racines (OK !)
		#===
		battlers.each do |i|
			if(i and !i.dead? and i.battle_effect.has_ingrain_effect?)
				BattleEngine::_mp([:msg, parse_text_with_pokemon(19, 739, i)])
				BattleEngine::_message_stack_push([:hp_up, i, i.max_hp / 16])
			end
		end
		#===
		#>Gestion de Anneau Hydro (OK !)
		#===
		battlers.each do |i|
			if(i and !i.dead? and i.battle_effect.has_aqua_ring_effect?)
				BattleEngine::_mp([:msg, parse_text_with_pokemon(19, 604, i)])
				BattleEngine::_message_stack_push([:hp_up, i, i.max_hp / 16])
			end
		end
		#===
		#>Gestion des capacités spéciales heal
		#===
		BattleEngine::Abilities.on_end_turn_heal_abilities
		phase4_message_display() if(BattleEngine::_message_stack_size>0)
		#===
		#>Effet des objets (OK ?)
		#===
		battlers.each do |i|
			#> Garde Magik
			if i.battle_effect.has_no_ability_effect? or i.ability != 17
				#>Boue Noire
				if(BattleEngine::_has_item(i, 281))
					if(i.type_poison?)
						return if i.max_hp == i.hp # Pas de proc si PV déjà aux max
						BattleEngine::_message_stack_push([:hp_up, i, (i.max_hp/20.0).round]) #nerfé légèrement comme pour les Restes, arrondi pour éviter un +0 PV.
					else
						BattleEngine::_message_stack_push([:hp_down, i, i.max_hp/8])
						i.loyalty -= 1
					end
				#>Orbe Flamme
				elsif(BattleEngine::_has_item(i, 273)) and i.can_be_burn?
					BattleEngine::_message_stack_push([:status_burn, i, true]) if i.battle_effect.nb_of_turn_here == 1
					i.loyalty -= 2 if !(i.ability == 10 || i.ability == 80 || i.ability == 89 || i.ability == 103) #Talent Cran, Écaille Spéciale, Pied Véloce ou Soin Poison
				#>Orbe Toxique
				elsif(BattleEngine::_has_item(i, 272)) and i.can_be_poisoned?
					BattleEngine::_message_stack_push([:status_toxic, i, true])	if i.battle_effect.nb_of_turn_here == 1
					i.loyalty -= 2 if !(i.ability == 10 || i.ability == 80 || i.ability == 103 || i.ability == 137) #Talent Cran, Écaille Spéciale, Pied Véloce ou Rage Brûlure
				#>Orbe Vie
				elsif(BattleEngine::_has_item(i, 270) && i.prepared_skill != 0 && i.hp>0)
					BattleEngine::_message_stack_push([:msgf, parse_text_with_pokemon(100, 65, i)]) # Message dégâts Orbe Vie
					BattleEngine::_message_stack_push([:hp_down, i, (i.max_hp/12.5).floor]) # Dégâts légèrements réduits pour compenser le proc de l'Orbe quelque soit l'attaque faite.
					i.loyalty -= 1
				#>Piquants
				elsif(BattleEngine::_has_item(i, 288))
					BattleEngine::_message_stack_push([:hp_down, i, i.max_hp/8])
				end
			end
			#>Restes
			if(BattleEngine::_has_item(i, 234))
			return if i.max_hp == i.hp # Pas de proc si PV déjà aux max
				BattleEngine::_message_stack_push([:hp_up, i, (i.max_hp/20.0).round]) #nerfé légèrement, arrondi pour éviter un +0 PV.
				BattleEngine::_message_stack_push([:msgf, parse_text_with_pokemon(100, 69, i)])
			end
		end
		#===
		#>Gestion de vampigraine (OK !)
		#===
		battlers.each do |i|
			if(i and i.hp>0 and i.battle_effect.has_leech_seed_effect?)
				#> Garde Magik
				next if !i.battle_effect.has_no_ability_effect? and i.ability == 17
				BattleEngine::_message_stack_push([:msgf, parse_text_with_pokemon(19, 610, i)])
				hp=(i.max_hp<8 ? 1 : i.max_hp/8)
				BattleEngine::_message_stack_push([:hp_down, i, hp, true])
				receiver=i.battle_effect.get_leech_seed_receiver
				if(receiver.battle_effect.has_heal_block_effect?)
					BattleEngine::_message_stack_push([:msg, parse_text_with_pokemon(19,890, receiver)])
					next
				end
				#>Grosse Racine
				hp = hp*130 / 100 if(BattleEngine::_has_item(receiver, 296))
				BattleEngine::_message_stack_push([:hp_up, receiver, hp])
				phase4_message_display()
			end
		end
		#===
		#>Modifications des status (OK !)
		#===
		battlers.each do |i|
			#> Garde Magik
			if i.battle_effect.has_no_ability_effect? or i.ability != 17
				_phase4_status_check(i)
			end
		end
		phase4_message_display() if(BattleEngine::_message_stack_size>0)
		#===
		#>Gestione de l'effet d'Etreinte (OK !)
		#===
		battlers.each do |i|
			if(i and i.hp>0 and i.battle_effect.has_bind_effect?)
				#> Garde Magik
				next if !i.battle_effect.has_no_ability_effect? and i.ability == 17
				hp = i.battle_effect.get_bind_power(i)
				BattleEngine::_message_stack_push([:msgf, parse_text_with_pokemon(19, 1086, i, MOVE[1] => i.battle_effect.get_bind_skill_name)])
				BattleEngine::_message_stack_push([:hp_down, i, hp, true])
				phase4_message_display()
			end
		end
		#===
		#>Cauchemard (OK !)
		#===
		battlers.each do |i|
			if(i and i.hp>0 and i.battle_effect.has_nightmare_effect?)
				#> Garde Magik
				next if !i.battle_effect.has_no_ability_effect? and i.ability == 17
				if(i.asleep?)
					hp=i.max_hp/4
					BattleEngine::_message_stack_push([:msgf, parse_text_with_pokemon(19, 324, i)])
					BattleEngine::_message_stack_push([:hp_down, i, hp, true])
					phase4_message_display()
				else
					i.battle_effect.apply_nightmare(false)
				end
			end
		end
		#===
		#>Malédication (OK !)
		#===
		battlers.each do |i|
			if(i and i.hp>0 and i.battle_effect.has_curse_effect?)
				#> Garde Magik
				next if !i.battle_effect.has_no_ability_effect? and i.ability == 17
				hp=i.max_hp/4
				BattleEngine::_message_stack_push([:msgf, parse_text_with_pokemon(19, 1077, i)])
				BattleEngine::_message_stack_push([:hp_down, i, hp, true])
				phase4_message_display()
			end
		end
		#===
		#> Mer de feu (aire de feu + aire d'herbe)
		#===
		if BattleEngine.state[:enn_firesea] > 0
			BattleEngine._msgp(18, 175, nil)
			@enemies[0, $game_temp.vs_type].each do |i|
				next if i.type_fire? or i.dead?
				BattleEngine::_message_stack_push([:hp_down, i, i.max_hp / 8, true])
			end
			phase4_message_display()
		end
		if BattleEngine.state[:act_firesea] > 0
			BattleEngine._msgp(18, 174, nil)
			@actors[0, $game_temp.vs_type].each do |i|
				next if i.type_fire? or i.dead?
				BattleEngine::_message_stack_push([:hp_down, i, i.max_hp / 8, true])
			end
			phase4_message_display()
		end
		#===
		#>Gestion des capacités spéciales en fin de tours
		#===
		BattleEngine::Abilities.on_end_turn_abilities
		phase4_message_display() if(BattleEngine::_message_stack_size>0)
		#===
		#>Baies
		#===
		battlers.each do |i|
			if(i and i.hp>0 and BattleEngine._has_item(i, i.battle_item))
				item_id = i.battle_item
				if(item_id >= 149 and item_id <= 157)
					if(heal_data = GameData::Item.heal_data(item_id) and 
							heal_data.states and heal_data.states.include?(i.status))
						BattleEngine::_mp([:berry_use, i, true])
						BattleEngine::_mp([:berry_cure, i, i.item_name])
						phase4_message_display()
					elsif(i.confused? and heal_data = GameData::Item.heal_data(item_id) and 
							heal_data.states and heal_data.states.include?(5))
						BattleEngine::_mp([:berry_use, i, true])
						BattleEngine::_mp([:confuse_cure, i, i.item_name])
						phase4_message_display()

					end
				end

			end
		end
		#>END

		
		BattleEngine::_State_update
		phase4_message_display() if(BattleEngine::_message_stack_size>0)
		BattleEngine.get_actors.each { |pokemon| pokemon&.battle_turns = 0 } if @exp_distributed
	end
end